Attribute VB_Name = "modFixtures"
Option Explicit

Type Match
    A   As String
    B   As String
End Type
'

Public Function GenerateFixtures(group() As String) As Match()
    
    Dim numGroups   As Long
    Dim perGroup    As Long
    Dim matches     As Long
    Dim i           As Long
    Dim k           As Long
    Dim l           As Long
    Dim m           As Long
    Dim col1()      As String
    Dim col2()      As String
    Dim ret()       As Match
    
    numGroups = UBound(group, 1)
    perGroup = UBound(group, 2)
    
    matches = perGroup - 1 + perGroup Mod 2
    
    l = Int((perGroup + 1) / 2)
    
    ReDim col1(0 To l)
    ReDim col2(0 To l)
    
    ReDim ret(1 To numGroups, 1 To matches, 1 To l)
    
    For i = 1 To numGroups
        
        For k = 0 To l - 1
            col1(k) = group(i, k + 1)
            If k + l + 1 > perGroup Then
                col2(l) = vbNullString
            Else
                col2(l - k - 1) = group(i, k + l + 1)
            End If
        Next
        
        For k = 1 To matches
            
            For m = 0 To l - 1
                ret(i, k, m + 1).A = col1(m)
                ret(i, k, m + 1).B = col2(m)
            Next
            
            For m = l To 1 Step -1
                col2(m) = col2(m - 1)
            Next
            
            col2(0) = col1(1)
            col1(l) = col2(l)
            
            
            For m = 1 To l - 1
                col1(m) = col1(m + 1)
            Next
            
            col1(l) = vbNullString
            col2(l) = vbNullString

        Next
    Next
    
    GenerateFixtures = ret

End Function
